/*jslint browser: true, indent : 2, nomen : true, sloppy : true */
/*global require: false */
(function () {
  "use strict";

  var IS_LOCAL  = /(:\/\/localhost|file:\/\/)/.test(document.location.href);

  require.config({
      waitSeconds :   (IS_LOCAL? 2 : 45)
 // , baseUrl:    "../"
 // , urlArgs: "bust=" + (new Date()).getTime()
 // , enforceDefine: true
    , paths: {
        controller:   '../js/controller'
      // requirejs plugin paths
      , text:         '../js/text'
      , json:         '../js/plugins/requirejs-plugins/json'
      , async:        '../js/plugins/requirejs-plugins/async'
      , css:           '../js/plugins/require-css/css'
      , normalize:     '../js/plugins/require-css/normalize'
      //, font:         '../js/plugins/requirejs-plugins/font'
      //, propertyParser:'../js/plugins/requirejs-plugins/propertyParser'

      // main module
      , overrides:    '../js/overrides'
      , jquery:       '../js/libs/jquery/jquery'
      , jqm:          '../js/libs/jqm/jqm'
      , i18next:      '../js/plugins/i18next/i18next'
      , renderjs:     '../js/plugins/renderjs/renderjs'
      , localstorage: '../js/libs/jio/localstorage'
      , queries:      '../js/libs/jio/complex_queries'
      , md5:          '../js/libs/jio/md5'
      , jio:          '../js/libs/jio/jio'

      // page modules
      , index:         '../js/modules/index'
      , legal:         '../js/modules/legal'
      , knowmore:      '../js/modules/knowmore'
      // content modules
      , gmaps:         '../js/plugins/jquery-ui-map/jquery.ui.map.module'
      , plot:          '../js/plugins/jqplot/jqplot.module'
      , header:        '../js/modules/header'
      , translate:     '../js/modules/translate'
      , social:        '../js/modules/social'
      , navigation:    '../js/modules/navigation'
      , configure:     '../js/modules/configure'
      , mapper:        '../js/modules/mapper'
    }
    , shim: {
        'overrides':     { deps: ['jquery'] }
      , 'jqm':           { deps: ['jquery'], exports: 'mobile' }
      , 'renderjs':      { deps: ['jquery', 'jio', 'md5', 'localstorage', 'queries'], exports: 'RenderJs' }
      , 'jio':           { deps: ['md5'] }
      , 'localstorage':  { deps: ['jio'] }
      , 'queries':       { deps: ['jio'] }
      , 'maps':          { deps: ['jquery', 'jqm']}
    }
    , map: {
      '*': {
        'css': '../js/plugins/require-css/css'
      }
    }
  });

// our main module to start the application
// controller.js is the first file to run
// alternatively this could be setup using a common module for all pages
// plus a page specific module for modules on a pages
define(
    [
        'require'
      , 'jquery'
      , 'jqm'
      , 'controller'
      , 'renderjs'
      , 'i18next'
      , 'overrides'
      , 'text'
      , 'json'
      , 'jio'
      // css files => handle & optimized require-css
      // done with https://github.com/guybedford/require-css
      // output to main.css (set in build.js)
      , 'css!../css/overrides'
      , 'css!../css/structure'
      , 'css!../css/themes'
      , 'css!../css/css'
    ],
  function(require, $, mobile, Controller, RenderJs){
      require([
      // get templates for controller
        'text!../gadgets/pageheader.html'
      , 'text!../gadgets/pagefooter.html'
      //  'json!../data/machine_pricing.json'
      //, 'json!../data/machine_parameters.json'
      // , 'font!google,families:[Open Sans:400]'
      ],
      function (){
        Controller.start();
        }
      );
    }
);
}());