define([
    'text!../gadgets/modules/configure.html!strip'
  , 'css!../css/modules/configure'
  ],
  function (source) {
    var response = {};
    response.data = source;
    response.callback = function () {
      var ajaxObject,
        getPositionInArray = function (element, array) {
          var i, l = array.length;
          for (i = 0; i < l; i += 1) {
            if (array[i] === element) {
              return i;
            }
          }
          return null;
        },

        findNearest = function (ar, num) {
          var i, closest, closestDiff, currentDiff;
          if (ar.length) {
            closest = ar[0];
            for (i = 0; i < ar.length; i +=1) {
              closestDiff = Math.abs(num - closest);
              currentDiff = Math.abs(num - ar[i]);
              if (currentDiff < closestDiff) {
                closest = ar[i];
              }
              closestDiff = null;
              currentDiff = null;
            }
          //returns first element that is closest to number
          return closest;
          }
        //no length
        return false;
        },

        updateForm = function (create) {
          var select_entry, select_entry_lc, opts = "", ips, input_slider, k, n,
            lookUpId, current_values, lookUpTxt,

            updateParameters = function ( $el, type ) {
              var allows, nearest, current_id, current_lookUp, l, current_profile,
                current_pass = false, remaining_parameters, remain_param, remain_id,
                updated_profiles = [], m = 0;

              // id and lookup
              current_id = $el.attr('id');
              current_lookUp = $.fn.fauna.references[current_id];

              // snap to closest value
              if (type === "range") {
                allows = $el.jqmData('allow').split(',');
                nearest = findNearest(allows, $el.val() );
                $el.val( nearest );
              } else {
                nearest = $el.val(); 
              }

              // loop profiles to find matches for this parameter
              for (l = 0; l < $.fn.fauna.profiles.length; l += 1) {
                current_profile = $.fn.fauna.profiles[l];

                if (current_profile[current_lookUp] === nearest) {
                  current_pass = true;

                  // does this profile also match all other criteria?
                  // careful with previsouly set criteria!
                  remaining_parameters = $('.search_parameters').not( $el ).not('span');
                  while (m < remaining_parameters.length) {
                    remain_param = remaining_parameters[m].value;
                    remain_id = remaining_parameters[m].getAttribute('id');
                    if (current_profile[$.fn.fauna.references[remain_id]] !== remain_param) {
                      if (remain_param !== "default" && remaining_parameters[m].getAttribute('data-default') === null) {
                        current_pass = false;
                        break;
                      }
                    }
                    m += 1;
                  }

                  if (current_pass) {
                    updated_profiles.unshift(current_profile);
                    // reset for next iteration
                    current_pass = false;
                    m = 0;
                  }
                }
              }
              // update number of matching profiles!
              if (updated_profiles.length === 0) {
                lookUpTxt = "";
              } else {
                lookUpTxt = " > ";
              }
              $('.records').text(lookUpTxt+ updated_profiles.length);

              // reset
              updated_profiles = [];
            };

          if (create) {
            // add select elements
            for (j = 0; j < $.fn.fauna.criteria["cpu_type"].length; j += 1) {
              select_entry = $.fn.fauna.criteria["cpu_type"][j];
              select_entry_lc = select_entry.toLowerCase();
              opts += '<option value="'+select_entry_lc+'">'+select_entry+'</option>';
            }
            $('#cpu_type')
              .append(opts)
              .selectmenu("refresh")
              .filter(function() { return $(this).jqmData('bound') !== true; })
              .jqmData('bound',true)
              .on( "change" , function( event, ui ) {
                updateParameters( $(this), "select");
              });
          }

          // fill sliders
          ips = $(document).find('input[data-type="range"]');

          for (k = 0; k < ips.length; k += 1) {

            input_slider = $( ips[k] );
            lookUpId = input_slider.attr('id');
            current_values = $.fn.fauna.criteria[lookUpId].sort(function(a,b) {return parseInt(a) > parseInt(b)});

            if ($.fn.fauna.criteria[lookUpId]) {
              input_slider.attr({
                'data-allow' : current_values,
                'min' :  current_values[0],
                'max' : current_values[current_values.length-1],
                // 'value': current_values[0],
                'data-default':current_values[0]
              })
              //.addClass('opq')
              .filter(function() { return $(this).jqmData('bound') !== true; })
              .jqmData('bound',true)
              .on( "slidestop.profiler" , function( event, ui ) {
                // moved = remove default
                $(this).removeAttr('data-default');
                $('.get_quote').removeClass("ui-disabled");
                //.removeClass('opq');
                updateParameters( $(this), "range" );
              })
              if (!create) {
              input_slider.slider("refresh");
              }
            }
          }

        },

        renderData = function (create) {
          var j, k, ajaxObject, sliders;

          // initialize item_configuration 
          if ($.fn.fauna.jio_item_config === undefined) {

            $.fn.fauna.jio_item_config = jIO.newJio({
              "type": "local",
              "username": "item_config",
              "application_name": "cloudquote"
            });

            require(["json!../data/machine_parameters.json"], function(data){
              var i = 0, j = 0, m, el, machine_property, x, z, arr, opts, slider, lookUpId, input_slider, current_values;
                $.fn.fauna.jio_machine_config = data;

                // create lookUp array and parameter array object
                $.fn.fauna.named_providers = [];
                $.fn.fauna.criteria = {};
                $.fn.fauna.profiles = [];
                $.fn.fauna.references = {};

                // loop machines, create lookUp and profile objects
                for (machine in data) {
                  arr = [];
                  if (data.hasOwnProperty(machine)) {
                    if (machine !== "COMP-1319") {
                      m = data[machine];
                      if (m["group"][0] !== "" && m["allocation_scope"][1] !== "Closed forever") {
                        el = m["group"][0].charAt(0).toUpperCase() + m["group"][0].slice(1)
                        $.fn.fauna.named_providers.push(el);

                        // build criteria
                        for (x in m ) {
                          if (m.hasOwnProperty(x)) {
                            // and anonymus profiles
                            arr.push(m[x][0]);

                            // check if parameter exists
                            if ( $.fn.fauna.criteria[x] === undefined) {
                            $.fn.fauna.criteria[x] = [];
                            }
                            // don't add empty strings
                            if (m[x][0] !== "") {
                              // check if value exists
                              if (getPositionInArray(m[x][0], $.fn.fauna.criteria[x]) === null) {
                                $.fn.fauna.criteria[x].push(m[x][0])
                              }
                            }
                            // build references
                            if (j === 0) {
                              $.fn.fauna.references[x] = i;
                            }
                          }
                          i += 1;
                        }
                      $.fn.fauna.profiles.unshift(arr);
                      j += 1;
                      }
                    }
                  }
                }
              // add default no of records
              $('.records').text(" > "+$.fn.fauna.profiles.length)

              // update form with profiles and available criteria
              updateForm(true);
            });

            // request pricing
            require(["json!../data/machine_pricing.json"], function(data){
              var quotation_for_machine, base_price, key, quote;

                $.fn.fauna.pricing = {};

                for (quotation_for_machine in data) {
                  if (data.hasOwnProperty(quotation_for_machine)) {
                    // add all prices for now, if n/a, differentiate later!
                    base_price = 0;
                    key = quotation_for_machine;
                    pricings = data[quotation_for_machine];
                    for (quotes in pricings) {
                      if (pricings.hasOwnProperty(quotes)) {
                        quote = pricings[quotes][0]
                        if (quote !== "n/a") {
                          base_price += 1*parseFloat(quote).toFixed(3)
                        }
                      }
                    }
                    $.fn.fauna.pricing[key] = base_price;
                  }
                }
            });
          }
        };

        // request apache-log and store in jIO
        $(document)
          .find(".menu_compare")
          .filter(function() { return $(this).jqmData('bound') !== true; })
          .jqmData('bound', true)
          .on('click', 'a', function (e) {
            var i, form_elems, form_elem_id, form_elem_val, form_elem_def;
              // add protocol here
              $.fn.fauna.formdata = "";
              if ($( e.target ).closest('a').is('.show_all') === false) {
                // manually serialize to allow exclusion of default values
                form_elems = $("form[name=compare]").find("input, select");
                for (i = 0; i < form_elems.length; i += 1) {
                  form_elem_id = form_elems[i].getAttribute('id');
                  form_elem_val = form_elems[i].value;
                  form_elem_def = form_elems[i].getAttribute('data-default');
                  if (form_elem_def === null && form_elem_val !== "default") {
                    $.fn.fauna.formdata += "&" + form_elem_id + "=" + form_elem_val;
                  }
                }
              }
              e.preventDefault();

              // ================= BOTTLENECK (if records increase) ==============
              // modified to only adding full records to the database, so if
              // a machine has no affiliated lookUp, it will not be added
              // this means there will be only 6 records in localstorage but it
              // will be fast - these will be the only records with pricing 
              // available, so the remaining 600+ COMP machines are currently 
              // not usable.
              $.fn.util.spin('show');

              // load records into JIO
              if ($.fn.fauna.items_loaded === undefined) {
                require(["json!../data/stats.json"], function (data) {
                  // https://www.slapos.org/ERP5Site_getCloudQuoteStats?jsoncallback=kartoffeln
                  var m, lookUp, machine_configuration, pass;

                    for (machine in data) {
                      if (data.hasOwnProperty(machine)) {
                        // VIP exclude Laurents laptop...
                        if (machine !== "COMP-1319") {
                          pass = true;
                          m = data[machine];
                          lookUp = $.fn.fauna.jio_machine_config[machine];
                          if (lookUp !== undefined) {
                            machine_configuration = {
                              _id: machine,
                              init : m["init"],
                              last : m["last"],
                              downtime : m["machine_downtime"],
                              totaltime : m["totaltime"],
                              percentile : m["percentile"],
                              ts : new Date(),
                              provider : lookUp["group"][0],
                              searchtext : lookUp["group"][0].toLowerCase() +", "
                                      + machine.toLowerCase(),
                              // parameters
                              storage_capacity : lookUp["storage_capacity"][0],
                              storage_capacity_i : lookUp["storage_capacity"][1],
                              memory_size : lookUp["memory_size"][0],
                              memory_size_i : lookUp["memory_size"][1],
                              cpu_frequency : lookUp["cpu_frequency"][0],
                              cpu_frequency_i : lookUp["cpu_frequency"][1],
                              cpu_type : lookUp["cpu_type"][0],
                              cpu_type_i : lookUp["cpu_type"][1]
                            }
                            if (lookUp["allocation_scope"][1] === "Closed forever") {
                              pass = false;
                            }
                          } else {
                            // never mind adding spam...
                            pass = false;
                          }
                          // also, cleanup of old records should be done here, 
                          // this would be for records in localstorage, which do
                          // not get updated when the application restarts, because
                          // it is no longer logged. Checking for the due date
                          // clears those records from eating localstorage space
                          // if (entry["ts"] < $.fn.fauna.items_good_until) {
                          //   $.fn.fauna.jio_item_config.delete({"_id":entry["_id"]})
                          // }

                          if (pass) {
                            $.fn.fauna.jio_item_config.put(machine_configuration);
                          }
                        }
                      }
                    $.fn.util.spin('hide');
                    $.fn.fauna.items_loaded = true;
                    }
                  }
                );
              }
              // ================= DO THIS ELSEWHERE ================

              // go to results page, this should be inside search callback
              $.mobile.changePage('results.html', {transition: 'fade'});
          });

          // HACK: not nice
          $(document).on('pagebeforeshow', '#index', function () {
            if ($.fn.fauna.reset === true) {
              delete $.fn.fauna.reset;
              renderData(true);
            }
          });

        // initializer
        renderData(true);

        // trigger enhancement
        $(document).ready(function() {
          var gadget = RenderJs.getSelfGadget();
          $(this).trigger("render_enhance", {gadget: gadget.dom});
        });
      };
  // return response object
  return response;
  }
);