define([
    'text!../gadgets/modules/header.html!strip'
  , 'css!../css/modules/header'
  ],
  function (source) {
    var response = {};
//     => get content of body, strip whitespace and linebreaks (done in build)
//     manually extract and compress file
//     extractBodyFrom = function (string) {
//       var regex = RegExp('<body>.*</body>'),
//         cleaned_string = string.replace(/(\r\n|\n|\r)/gm,"").replace(/\s+/g," "),
//         tmpl = cleaned_string.match(regex);
//       return tmpl[0].slice(6,-7);
//     };

//     => use blob to access elements in string
//     use a blob to convert an HTML string, make fake url request to 
//     to convert to searchable like so:
//     var html_blob = new Blob([html_string], "text/html")
//     var html_url = html_blob.createBlobUrl();
//     $.ajax({url: html_url, dataType: "xml"}).done(function (data) {
//       var data = $(data);
//       data.find("html head meta").remove();
//       data.find("html head title").remove();
//       data.find('script[type="text/javascript"]').clear();
//     });

    response.data = source;
    response.callback = function () {
      var gadget = RenderJs.getSelfGadget(),
        recursive_gadgets = gadget.dom.find("[data-gadget]").not(".main-interactor"),
        len = recursive_gadgets.length;

      // this retrieves data-gadget-property JSON and passes on information
      // to self (for this gadget) and further recursive gadgets
      // I'm using this in every gadgets, so if this is ever made into a
      // generic behavior, it should probably be used inside renderJS vs
      // inside every individual gadget
      recursive_gadgets.each(function (i) {
        var passJSON = gadget[$(this).attr('id')],
          string,
          new_string,
          // 1. instantiate: prepend recursive gadget_id with parent gadget_id
          current_id = $(this).attr('id'),
          new_id = current_id+"__"+gadget.dom.attr('id');

        // 2. pass on JSON BEFORE resetting gadget_id
        if (passJSON !== undefined) {
          $(this).attr('data-gadget-property','{"self":'+JSON.stringify(passJSON)+'}');
        }

        // 3. reset
        $(this).attr('id', new_id);

        // 4. update gadget interactions
        string = gadget.dom.find(".main-interactor").attr("data-gadget-connection");
        if (string !== undefined) {
          new_string = string.replace(current_id,new_id);
          gadget.dom.find(".main-interactor").attr("data-gadget-connection",new_string);
        }
      });

      // 5. set JSON properties passed to "self" (this gadget) on gadget.dom
      if (gadget.self !== undefined) {
        for (key in gadget.self) {
          if (gadget.self.hasOwnProperty(key)) {
            gadget.dom.find(key).attr(gadget.self[key][0],gadget.self[key][1]);
          }
        }
      }

      // JQM trigger create > should be called here vs inside controller
      // alternative is before ready (see translate.js)
      $(document).ready(function() {
        $(this).trigger("render_enhance", {gadget: gadget.dom});
      });
    };
  // return response object
  return response;
  }
);