/*jslint browser: true, continue : true, devel : true, indent : 4, maxerr : 50, 
newcap : true, nomen : true, plusplus : true, regexp : true, sloppy : true, 
vars : true, white : true */
/*global jQuery: false, $: false, document: false */
(function ($, document) {
    "use strict";

    $(document).bind("mobileinit", function () {

        var evt;

        // [JQM] - prevent confilicts with requireJS docReady by triggering JQM manually
        $.mobile.autoInitializePage = false;

        // [JQM] - disable pushState to ensure URLs will be correct
        // $.mobile.pushStateEnabled = false;

        // [Google Analytics] - since we are tracking on pageshow the pageshow
        // listener in tmp_pagefooter must be wrapped in a javascript function 
        // which is triggered here. Otherwise $(document).on('pageshow ...
        // will throw an error, because when it's parsed on the page, jQuery and 
        // JQM will not have loaded since we are using requireJS.
        // 
        // Hence the pagefooter has a javascript-only wrapper listening for 
        // the custom "jqmReady" event. Since you can't listen for custom
        // events on IE8, we are using a property named jqmReady (set to 0)
        // and instead of triggering jqmReady, we trigger onpropertychange
        // by setting increasing the value by 1. On IE8, this will trigger
        // onpropertychange inside mobilinit (which only triggers when 
        // jQuery and JQM have been loaded, which again will trigger the 
        // pageshow binding inside triggerAnalytics
       if (document.createEvent) {
            evt = document.createEvent("Event");
            evt.initEvent("jqmReady", true, true);
            document.dispatchEvent(evt);
        // IE8
        } else if (document.createEventObject) { 
            document.documentElement.jqmReady++;
        }
    });
}(jQuery, document));